%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

Name:           ocaml-qcheck
Version:        0.24
Release:        %mkrel 1
Summary:        QuickCheck inspired property-based testing for OCaml

Group:          Development/OCaml
License:        BSD
URL:            https://c-cube.github.io/qcheck/
Source0:        https://github.com/c-cube/qcheck/archive/v%{version}/%{name}-%{version}.tar.gz
# Expose a dependency on the math library so RPM can see it
Patch:          %{name}-mathlib.patch
# Work around asciidoc errors due to unspecified language
# https://github.com/c-cube/qcheck/issues/325
Patch:          %{name}-asciidoc.patch

BuildRequires:  asciidoc
BuildRequires:  ocaml >= 4.08.0
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-alcotest-devel
BuildRequires:  ocaml-ounit-devel
BuildRequires:  ocaml-ppxlib-devel >= 0.22.0
BuildRequires:  ocaml-ppx_deriving-devel >= 5.2.1
BuildRequires:  python3-pygments

Requires:       %{name}-core%{?_isa} = %{version}-%{release}
Requires:       %{name}-ounit%{?_isa} = %{version}-%{release}

%global _desc %{expand:
Qcheck enables checking invariants (properties of a type) over randomly
generated instances of the type.  It provides combinators for generating
instances and printing them.}

%description %_desc

This package is a compatibility wrapper for qcheck.  New code should
use either ocaml-qcheck-alcotest or ocaml-qcheck-ounit.


%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}
Requires:       %{name}-ounit-devel%{?_isa} = %{version}-%{release}


%description    devel %_desc

The %{name}-devel package contains libraries and signature files
for developing applications that use the qcheck compatibility wrapper.
New code should instead use %{name}-alcotest-devel or
%{name}-ounit-devel.


%package        core
Summary:        QuickCheck inspired property-based testing for OCaml


%description    core %_desc
This package provides alcotest support for qcheck.


%package        core-devel
Summary:        Development files for %{name}-core
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    core-devel %_desc

The %{name}-core-devel package contains libraries and signature
files for developing applications that use %{name}-core.


%package        ounit
Summary:        OUnit support for %{name}
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    ounit %_desc

This package provides ounit support for qcheck.


%package        ounit-devel
Summary:        Development files for %{name}-ounit
Requires:       %{name}-ounit%{?_isa} = %{version}-%{release}
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}
Requires:       ocaml-ounit-devel%{?_isa}


%description    ounit-devel %_desc

The %{name}-ounit-devel package contains libraries and signature
files for developing applications that use %{name}-ounit.


%package        alcotest
Summary:        Alcotest support for %{name}
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    alcotest %_desc

This package provides alcotest support for qcheck.


%package        alcotest-devel
Summary:        Development files for %{name}-alcotest
Requires:       %{name}-alcotest%{?_isa} = %{version}-%{release}
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}
Requires:       ocaml-alcotest-devel%{?_isa}


%description    alcotest-devel %_desc

The %{name}-alcotest-devel package contains libraries and signature
files for developing applications that use %{name}-alcotest.


%package     -n ocaml-ppx_deriving_qcheck
Summary:        PPX deriver for QCheck
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description  -n ocaml-ppx_deriving_qcheck %_desc

This package provides a PPX deriver for QCheck.


%package     -n ocaml-ppx_deriving_qcheck-devel
Summary:        Development files for ocaml-ppx_deriving_qcheck
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}
Requires:       ocaml-ppxlib-devel%{?_isa}


%description -n ocaml-ppx_deriving_qcheck-devel %_desc

The ocaml-ppx_deriving_qcheck-devel package contains libraries and
signature files for developing applications that use
ocaml-ppx_deriving_qcheck.


%prep
%autosetup -n qcheck-%{version} -p1


%build
%dune_build
asciidoc README.adoc


%install
%dune_install -s


%check
%dune_check


%files -f .ofiles-qcheck
%doc README.html CHANGELOG.md
%license LICENSE


%files devel -f .ofiles-qcheck-devel
%doc README.html CHANGELOG.md
%license LICENSE


%files core -f .ofiles-qcheck-core


%files core-devel -f .ofiles-qcheck-core-devel


%files ounit -f .ofiles-qcheck-ounit


%files ounit-devel -f .ofiles-qcheck-ounit-devel


%files alcotest -f .ofiles-qcheck-alcotest


%files alcotest-devel -f .ofiles-qcheck-alcotest-devel

%files -n ocaml-ppx_deriving_qcheck -f .ofiles-ppx_deriving_qcheck

%files -n ocaml-ppx_deriving_qcheck-devel -f .ofiles-ppx_deriving_qcheck-devel


%changelog
* Thu Jun 19 2025 daviddavid <daviddavid> 0.24-1.mga10
+ Revision: 2192931
- new version: 0.24

* Sun Dec 11 2022 pterjan <pterjan> 0.20-2.mga9
+ Revision: 1920606
- Rebuild for new ppxlib

* Fri Dec 09 2022 pterjan <pterjan> 0.20-1.mga9
+ Revision: 1920118
- Update to 0.20

* Sun Oct 09 2022 pterjan <pterjan> 0.19.1-1.mga9
+ Revision: 1895901
- Update to 0.19.1

* Wed May 25 2022 pterjan <pterjan> 0.18.1-1.mga9
+ Revision: 1860136
- Update to 0.18.1

* Fri May 20 2022 pterjan <pterjan> 0.18-2.mga9
+ Revision: 1859415
- Rebuild for OCaml 4.14

* Fri Oct 15 2021 tv <tv> 0.18-1.mga9
+ Revision: 1751508
- Ignore testsuite failure for now
- Version 0.18
- Split into subpackages to manage dependencies
- Move META to the main package
- Disable debuginfo

* Thu Mar 25 2021 tv <tv> 0.17-1.mga9
+ Revision: 1709750
- Enable debuginfo
- 0.17

* Sun Jan 10 2021 pterjan <pterjan> 0.13-3.mga8
+ Revision: 1670732
- Rebuild to generate ocamlx provides

* Sun Mar 01 2020 pterjan <pterjan> 0.13-2.mga8
+ Revision: 1552712
- Rebuild with required dependencies installed

* Sun Mar 01 2020 pterjan <pterjan> 0.13-1.mga8
+ Revision: 1552690
- imported package ocaml-qcheck

